# -*- coding:Utf-8 -*-


# ==================================================
# >> IMPORTATIONS
# ==================================================


import es
import vecmath
import gamethread

import os

import psyco
psyco.full()


# ==================================================
# >> INFORMATIONS
# ==================================================


g_informations = es.AddonInfo()
g_informations["name"] = "Daggers by L'In20Cible"
g_informations["version"] = "1.1"
g_informations["date"] = "2010-07-03"
g_informations["author"] = "L\'in20Cible"
g_informations["url"] = "http://addons.eventscripts.com/addons/view/daggers/"
g_informations["basename"] = "daggers"

es.ServerVar("daggers_version", (g_informations["version"] + " by " + g_informations["author"])).makepublic()


# ==================================================
# >> GLOBALES
# ==================================================


g_options = {
   "enable"      : [1  , "daggers_enable <1/0> -- Active/Désactive les fonctionnalités du script Daggers."],
   "distance"    : [750, "dagger_distance <1/0> -- Définit la distance du lancé."],
   "effects"     : [1  , "daggers_trails <1/0> -- Active/Désactive l'effet sur les couteaux."],
   "friendlyfire": [0  , "daggers_friendlyfire <1/0> -- Active/Désactive le tir fraternel."]
   }
for option in g_options:
   g_options[option] = es.ServerVar((g_informations["basename"] + "_" + option), g_options[option][0], g_options[option][1])
   
   
# ==================================================
# >> INITIALISATION
# ==================================================


def load():
   __init__()
   es.addons.registerTickListener(TickListenerCallBack)
   es.addons.registerClientCommandFilter(ClientCommandFilterCallBack)
   
   
def __init__():
   path = os.path.join(str(es.ServerVar("eventscripts_gamedir")), "cfg", "eventscripts", g_informations["basename"], "configuration.cfg").replace(os.sep, "/")
   if not os.path.isfile(path):
      return
   es.mexec(path.replace(str(es.ServerVar("eventscripts_lastgive")).replace(os.sep, "/"), ".."))
   
   
def unload():
   es.addons.unregisterTickListener(TickListenerCallBack)
   es.addons.unregisterClientCommandFilter(ClientCommandFilterCallBack)
   
   
# ==================================================
# >> UTILITAIRES
# ==================================================


def RemoveEntityIndex(index):
   userid = int(es.getuserid())
   if not es.exists("userid", userid) or (index not in es.createentitylist()):
      return
   es.entitysetvalue(index, "targetname", index)
   es.fire(userid, index, "kill")
   
   
def GetPlayerKnifeIndex(userid):
   returnvalue = -1
   for index in es.createentitylist("weapon_knife"):
      if (es.getindexprop(index, "CBaseCombatWeapon.m_hOwner") != es.getplayerhandle(userid)):
         continue
      returnvalue = index
      break
   return returnvalue
   
   
def MakePlayerDamage(userid, attacker):
   if not int(g_options["friendlyfire"]) and (es.getplayerteam(userid) == es.getplayerteam(attacker)):
      return
   es.server.queuecmd("damage %s %s 32 %s" % (userid, es.getplayerprop(userid, "CBasePlayer.m_iHealth"), attacker))
   
   
def GetPlayerViewTarget(userid):
   returnvalue = -1
   index = GetPlayerViewProp(userid)
   for userid in es.getUseridList():
      if (es.createplayerlist(userid)[userid]["index"] != index):
         continue
      returnvalue = userid
      break
   return returnvalue
   
   
def GetPlayerEyeCoord(userid):
   returnvalue = "0,0,0"
   x, y, z = es.getplayerlocation(userid)
   z = (z + 66.7)
   if (es.getplayerprop(userid, 'CBasePlayer.localdata.m_Local.m_bDucked') % 2):
      z = (z - 16.1)
   return es.createvectorstring(x, y, z)
   
   
def GetPlayerViewProp(userid):
   returnvalue = -1
   ExecutePlayerCheat(userid, "ent_setname daggers_viewed_prop")
   for index in es.createentitylist():
      if (es.entitygetvalue(index, "targetname") != "daggers_viewed_prop"):
         continue
      returnvalue = index
      break
   return returnvalue
   
   
def ExecutePlayerCheat(userid, string):
   if not int(es.ServerVar("sv_cheats")):
      es.forcevalue("sv_cheats", 1)
      es.sexec(userid, string)
      es.forcevalue("sv_cheats", 0)
   else:
      es.sexec(userid, string)
      
      
def GetPlayerViewCoord(userid):
   returnvalue = "0,0,0"
   entities = es.createentitylist("prop_dynamic")
   ExecutePlayerCheat(userid, "prop_dynamic_create props_c17/tv_monitor01_screen.mdl")
   for index in es.createentitylist("prop_dynamic"):
      if (index in entities):
         continue
      returnvalue = es.getindexprop(index, "CBaseEntity.m_vecOrigin")
      RemoveEntityIndex(index)
   return returnvalue
   
   
# ==================================================
# >> FONCTIONS D'APPEL
# ==================================================


def TickListenerCallBack():
   if not int(g_options["enable"]) or not int(g_options["effects"]):
      return
   for index in es.createentitylist("weapon_knife"):
      if (es.getindexprop(index, "CBaseCombatWeapon.m_hOwner") != -1):
         continue
      origin = es.getindexprop(index, "CBaseEntity.m_vecOrigin")
      es.effect("energysplash", origin, origin, 0)


def ClientCommandFilterCallBack(userid, arguments):
   if int(g_options["enable"]) and (arguments[0].lower() == "drop") and not es.getplayerprop(userid, "CBasePlayer.pl.deadflag") and (es.createplayerlist(userid)[userid]["weapon"] == "weapon_knife"):
      index = GetPlayerKnifeIndex(userid)
      if index:
         es.cexec(userid, "lastinv")
         gamethread.delayed(0.2, RemoveEntityIndex, index)
      origin = GetPlayerEyeCoord(userid)
      target = GetPlayerViewTarget(userid)
      if (target != -1) and (vecmath.distance(origin, es.getplayerlocation(target)) < int(g_options["distance"])):
         gamethread.delayed(0.1, MakePlayerDamage, (target, userid))
         vector = vecmath.vector(es.createvectorfrompoints(origin, GetPlayerEyeCoord(target)))
      else:
         vector = vecmath.vector(es.createvectorfrompoints(origin, GetPlayerViewCoord(userid)))
      vector = (vector * int(g_options["distance"]))
      index = es.createentity("weapon_knife")
      outputs = {
         "origin"    : origin.replace(",", " "),
         "angles"    : es.createvectorstring(45, es.getplayerprop(userid, "CCSPlayer.m_angEyeAngles[1]"), 0.0).replace(",", " "),
         "targetname": ("dagger_%s" % index)
         }
      for output in outputs:
         es.entitysetvalue(index, output, outputs[output])
      es.spawnentity(index)
      es.fire(userid, ("dagger_%s" % index), "wake")
      es.delayed(0, "es_xphysics active setvelocity %i %s" % (index, vector))
      es.emitsound("entity", index, "weapons/iceaxe/iceaxe_swing1.wav", 1.0, 0.5)
   return True
   
   
# ==================================================
# >> ÉVÉNEMENTS
# ==================================================


def es_map_start(event_var):
   __init__()
   
   
def player_spawn(event_var):
   userid = int(event_var["userid"])
   if not int(g_options["enable"]) or (GetPlayerKnifeIndex(userid) != -1) or (int(event_var["es_userteam"]) not in [2, 3]):
      return
   es.give(userid, "weapon_knife")